note
   description: "Button with command list to specify behaviour"

class BUTTON

create set_command

--------------------------------------------------------------------------------
feature -- Commands

set_command (new_command : COMMAND)
    -- Register a new COMMAND
  require
    new_command_not_void: new_command /= Void
  do
    associated_command := new_command
  ensure
    associated_command = new_command
  end

activate
  -- Execute the associated_command
    do
    associated_command.execute
  end

--------------------------------------------------------------------------------
feature {NONE} -- Private

associated_command : COMMAND
    -- Command that must be executed when the BUTTON is pressed

invariant
  associated_command_not_void: associated_command /= Void

end
