note
   description: "Example application of the Command design pattern: an interactive application"

class MAIN

create make

--------------------------------------------------------------------------------
feature {NONE} -- Creation

make
  local
    editor : TEXT_EDITOR
    save_button, quit_button: BUTTON
    save_command : SAVE_COMMAND
    quit_command : QUIT_COMMAND
  do
    create editor

    -- Create the commands and associate them with the editor

    create save_command.make(editor)
    create quit_command.make(editor)

    -- Create the buttons and associate them with the commands

    create save_button.set_command(save_command)
    create quit_button.set_command(quit_command)

    -- Simulate pressing the buttons

    print("Pressing button SAVE: ")
    save_button.activate
    print("Pressing button QUIT: ")
    quit_button.activate
  end

end
